/*
 * This file is part of Cleanflight.
 *
 * Cleanflight is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Cleanflight is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cleanflight.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

// this file is automatically generated by src/utils/def_generated.pl script
// do not modify this file directly, your changes will be lost

// DEFIO_PORT_<port>_USED_MASK is bitmask of used pins on target
// DEFIO_PORT_<port>_USED_COUNT is count of used pins on target

#if defined(TARGET_IO_PORT0)
# define DEFIO_PORT_0_USED_MASK TARGET_IO_PORT0
# define DEFIO_PORT_0_USED_COUNT BITCOUNT(DEFIO_PORT_0_USED_MASK)
#else
# define DEFIO_PORT_0_USED_MASK 0
# define DEFIO_PORT_0_USED_COUNT 0
#endif
#define DEFIO_PORT_0_OFFSET (0)

#if defined(TARGET_IO_PORT1)
# define DEFIO_PORT_1_USED_MASK TARGET_IO_PORT1
# define DEFIO_PORT_1_USED_COUNT BITCOUNT(DEFIO_PORT_1_USED_MASK)
#else
# define DEFIO_PORT_1_USED_MASK 0
# define DEFIO_PORT_1_USED_COUNT 0
#endif
#define DEFIO_PORT_1_OFFSET (DEFIO_PORT_0_USED_COUNT)

#if defined(TARGET_IO_PORT2)
# define DEFIO_PORT_2_USED_MASK TARGET_IO_PORT2
# define DEFIO_PORT_2_USED_COUNT BITCOUNT(DEFIO_PORT_2_USED_MASK)
#else
# define DEFIO_PORT_2_USED_MASK 0
# define DEFIO_PORT_2_USED_COUNT 0
#endif
#define DEFIO_PORT_2_OFFSET (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)

#if defined(TARGET_IO_PORT3)
# define DEFIO_PORT_3_USED_MASK TARGET_IO_PORT3
# define DEFIO_PORT_3_USED_COUNT BITCOUNT(DEFIO_PORT_3_USED_MASK)
#else
# define DEFIO_PORT_3_USED_MASK 0
# define DEFIO_PORT_3_USED_COUNT 0
#endif
#define DEFIO_PORT_3_OFFSET (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)

#if defined(TARGET_IO_PORT4)
# define DEFIO_PORT_4_USED_MASK TARGET_IO_PORT4
# define DEFIO_PORT_4_USED_COUNT BITCOUNT(DEFIO_PORT_4_USED_MASK)
#else
# define DEFIO_PORT_4_USED_MASK 0
# define DEFIO_PORT_4_USED_COUNT 0
#endif
#define DEFIO_PORT_4_OFFSET (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)

#if defined(TARGET_IO_PORT5)
# define DEFIO_PORT_5_USED_MASK TARGET_IO_PORT5
# define DEFIO_PORT_5_USED_COUNT BITCOUNT(DEFIO_PORT_5_USED_MASK)
#else
# define DEFIO_PORT_5_USED_MASK 0
# define DEFIO_PORT_5_USED_COUNT 0
#endif
#define DEFIO_PORT_5_OFFSET (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)

#if defined(TARGET_IO_PORT6)
# define DEFIO_PORT_6_USED_MASK TARGET_IO_PORT6
# define DEFIO_PORT_6_USED_COUNT BITCOUNT(DEFIO_PORT_6_USED_MASK)
#else
# define DEFIO_PORT_6_USED_MASK 0
# define DEFIO_PORT_6_USED_COUNT 0
#endif
#define DEFIO_PORT_6_OFFSET (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)



// DEFIO_GPIOID__<port> maps to port index
#define DEFIO_GPIOID__0 0
#define DEFIO_GPIOID__1 1
#define DEFIO_GPIOID__2 2
#define DEFIO_GPIOID__3 3
#define DEFIO_GPIOID__4 4
#define DEFIO_GPIOID__5 5
#define DEFIO_GPIOID__6 6

// DEFIO_TAG__P<port><pin> will expand to TAG if defined for target, error is triggered otherwise
// DEFIO_TAG_E__P<port><pin> will expand to TAG if defined, to NONE otherwise (usefull for tables that are CPU-specific)
// DEFIO_REC__P<port><pin> will expand to ioRec* (using DEFIO_REC_INDEX(idx))

#if DEFIO_PORT_0_USED_MASK & BIT(0)
# define DEFIO_TAG__P00 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 0)
# define DEFIO_TAG_E__P00 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 0)
# define DEFIO_REC__P00 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(0) - 1)) + 0)
#else
# define DEFIO_TAG__P00 defio_error_P00_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P00 DEFIO_TAG_E__NONE
# define DEFIO_REC__P00 defio_error_P00_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(1)
# define DEFIO_TAG__P01 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 1)
# define DEFIO_TAG_E__P01 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 1)
# define DEFIO_REC__P01 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(1) - 1)) + 0)
#else
# define DEFIO_TAG__P01 defio_error_P01_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P01 DEFIO_TAG_E__NONE
# define DEFIO_REC__P01 defio_error_P01_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(2)
# define DEFIO_TAG__P02 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 2)
# define DEFIO_TAG_E__P02 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 2)
# define DEFIO_REC__P02 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(2) - 1)) + 0)
#else
# define DEFIO_TAG__P02 defio_error_P02_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P02 DEFIO_TAG_E__NONE
# define DEFIO_REC__P02 defio_error_P02_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(3)
# define DEFIO_TAG__P03 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 3)
# define DEFIO_TAG_E__P03 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 3)
# define DEFIO_REC__P03 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(3) - 1)) + 0)
#else
# define DEFIO_TAG__P03 defio_error_P03_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P03 DEFIO_TAG_E__NONE
# define DEFIO_REC__P03 defio_error_P03_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(4)
# define DEFIO_TAG__P04 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 4)
# define DEFIO_TAG_E__P04 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 4)
# define DEFIO_REC__P04 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(4) - 1)) + 0)
#else
# define DEFIO_TAG__P04 defio_error_P04_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P04 DEFIO_TAG_E__NONE
# define DEFIO_REC__P04 defio_error_P04_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(5)
# define DEFIO_TAG__P05 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 5)
# define DEFIO_TAG_E__P05 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 5)
# define DEFIO_REC__P05 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(5) - 1)) + 0)
#else
# define DEFIO_TAG__P05 defio_error_P05_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P05 DEFIO_TAG_E__NONE
# define DEFIO_REC__P05 defio_error_P05_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(6)
# define DEFIO_TAG__P06 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 6)
# define DEFIO_TAG_E__P06 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 6)
# define DEFIO_REC__P06 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(6) - 1)) + 0)
#else
# define DEFIO_TAG__P06 defio_error_P06_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P06 DEFIO_TAG_E__NONE
# define DEFIO_REC__P06 defio_error_P06_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(7)
# define DEFIO_TAG__P07 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 7)
# define DEFIO_TAG_E__P07 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 7)
# define DEFIO_REC__P07 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(7) - 1)) + 0)
#else
# define DEFIO_TAG__P07 defio_error_P07_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P07 DEFIO_TAG_E__NONE
# define DEFIO_REC__P07 defio_error_P07_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(8)
# define DEFIO_TAG__P08 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 8)
# define DEFIO_TAG_E__P08 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 8)
# define DEFIO_REC__P08 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(8) - 1)) + 0)
#else
# define DEFIO_TAG__P08 defio_error_P08_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P08 DEFIO_TAG_E__NONE
# define DEFIO_REC__P08 defio_error_P08_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(9)
# define DEFIO_TAG__P09 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 9)
# define DEFIO_TAG_E__P09 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 9)
# define DEFIO_REC__P09 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(9) - 1)) + 0)
#else
# define DEFIO_TAG__P09 defio_error_P09_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P09 DEFIO_TAG_E__NONE
# define DEFIO_REC__P09 defio_error_P09_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(10)
# define DEFIO_TAG__P010 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 10)
# define DEFIO_TAG_E__P010 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 10)
# define DEFIO_REC__P010 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(10) - 1)) + 0)
#else
# define DEFIO_TAG__P010 defio_error_P010_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P010 DEFIO_TAG_E__NONE
# define DEFIO_REC__P010 defio_error_P010_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(11)
# define DEFIO_TAG__P011 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 11)
# define DEFIO_TAG_E__P011 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 11)
# define DEFIO_REC__P011 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(11) - 1)) + 0)
#else
# define DEFIO_TAG__P011 defio_error_P011_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P011 DEFIO_TAG_E__NONE
# define DEFIO_REC__P011 defio_error_P011_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(12)
# define DEFIO_TAG__P012 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 12)
# define DEFIO_TAG_E__P012 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 12)
# define DEFIO_REC__P012 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(12) - 1)) + 0)
#else
# define DEFIO_TAG__P012 defio_error_P012_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P012 DEFIO_TAG_E__NONE
# define DEFIO_REC__P012 defio_error_P012_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(13)
# define DEFIO_TAG__P013 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 13)
# define DEFIO_TAG_E__P013 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 13)
# define DEFIO_REC__P013 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(13) - 1)) + 0)
#else
# define DEFIO_TAG__P013 defio_error_P013_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P013 DEFIO_TAG_E__NONE
# define DEFIO_REC__P013 defio_error_P013_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(14)
# define DEFIO_TAG__P014 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 14)
# define DEFIO_TAG_E__P014 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 14)
# define DEFIO_REC__P014 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(14) - 1)) + 0)
#else
# define DEFIO_TAG__P014 defio_error_P014_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P014 DEFIO_TAG_E__NONE
# define DEFIO_REC__P014 defio_error_P014_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_0_USED_MASK & BIT(15)
# define DEFIO_TAG__P015 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 15)
# define DEFIO_TAG_E__P015 DEFIO_TAG_MAKE(DEFIO_GPIOID__0, 15)
# define DEFIO_REC__P015 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_0_USED_MASK & (BIT(15) - 1)) + 0)
#else
# define DEFIO_TAG__P015 defio_error_P015_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P015 DEFIO_TAG_E__NONE
# define DEFIO_REC__P015 defio_error_P015_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(0)
# define DEFIO_TAG__P10 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 0)
# define DEFIO_TAG_E__P10 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 0)
# define DEFIO_REC__P10 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P10 defio_error_P10_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P10 DEFIO_TAG_E__NONE
# define DEFIO_REC__P10 defio_error_P10_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(1)
# define DEFIO_TAG__P11 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 1)
# define DEFIO_TAG_E__P11 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 1)
# define DEFIO_REC__P11 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P11 defio_error_P11_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P11 DEFIO_TAG_E__NONE
# define DEFIO_REC__P11 defio_error_P11_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(2)
# define DEFIO_TAG__P12 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 2)
# define DEFIO_TAG_E__P12 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 2)
# define DEFIO_REC__P12 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P12 defio_error_P12_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P12 DEFIO_TAG_E__NONE
# define DEFIO_REC__P12 defio_error_P12_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(3)
# define DEFIO_TAG__P13 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 3)
# define DEFIO_TAG_E__P13 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 3)
# define DEFIO_REC__P13 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P13 defio_error_P13_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P13 DEFIO_TAG_E__NONE
# define DEFIO_REC__P13 defio_error_P13_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(4)
# define DEFIO_TAG__P14 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 4)
# define DEFIO_TAG_E__P14 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 4)
# define DEFIO_REC__P14 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P14 defio_error_P14_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P14 DEFIO_TAG_E__NONE
# define DEFIO_REC__P14 defio_error_P14_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(5)
# define DEFIO_TAG__P15 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 5)
# define DEFIO_TAG_E__P15 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 5)
# define DEFIO_REC__P15 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P15 defio_error_P15_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P15 DEFIO_TAG_E__NONE
# define DEFIO_REC__P15 defio_error_P15_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(6)
# define DEFIO_TAG__P16 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 6)
# define DEFIO_TAG_E__P16 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 6)
# define DEFIO_REC__P16 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P16 defio_error_P16_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P16 DEFIO_TAG_E__NONE
# define DEFIO_REC__P16 defio_error_P16_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(7)
# define DEFIO_TAG__P17 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 7)
# define DEFIO_TAG_E__P17 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 7)
# define DEFIO_REC__P17 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P17 defio_error_P17_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P17 DEFIO_TAG_E__NONE
# define DEFIO_REC__P17 defio_error_P17_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(8)
# define DEFIO_TAG__P18 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 8)
# define DEFIO_TAG_E__P18 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 8)
# define DEFIO_REC__P18 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P18 defio_error_P18_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P18 DEFIO_TAG_E__NONE
# define DEFIO_REC__P18 defio_error_P18_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(9)
# define DEFIO_TAG__P19 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 9)
# define DEFIO_TAG_E__P19 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 9)
# define DEFIO_REC__P19 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P19 defio_error_P19_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P19 DEFIO_TAG_E__NONE
# define DEFIO_REC__P19 defio_error_P19_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(10)
# define DEFIO_TAG__P110 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 10)
# define DEFIO_TAG_E__P110 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 10)
# define DEFIO_REC__P110 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P110 defio_error_P110_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P110 DEFIO_TAG_E__NONE
# define DEFIO_REC__P110 defio_error_P110_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(11)
# define DEFIO_TAG__P111 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 11)
# define DEFIO_TAG_E__P111 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 11)
# define DEFIO_REC__P111 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P111 defio_error_P111_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P111 DEFIO_TAG_E__NONE
# define DEFIO_REC__P111 defio_error_P111_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(12)
# define DEFIO_TAG__P112 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 12)
# define DEFIO_TAG_E__P112 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 12)
# define DEFIO_REC__P112 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P112 defio_error_P112_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P112 DEFIO_TAG_E__NONE
# define DEFIO_REC__P112 defio_error_P112_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(13)
# define DEFIO_TAG__P113 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 13)
# define DEFIO_TAG_E__P113 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 13)
# define DEFIO_REC__P113 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P113 defio_error_P113_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P113 DEFIO_TAG_E__NONE
# define DEFIO_REC__P113 defio_error_P113_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(14)
# define DEFIO_TAG__P114 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 14)
# define DEFIO_TAG_E__P114 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 14)
# define DEFIO_REC__P114 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P114 defio_error_P114_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P114 DEFIO_TAG_E__NONE
# define DEFIO_REC__P114 defio_error_P114_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_1_USED_MASK & BIT(15)
# define DEFIO_TAG__P115 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 15)
# define DEFIO_TAG_E__P115 DEFIO_TAG_MAKE(DEFIO_GPIOID__1, 15)
# define DEFIO_REC__P115 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_1_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT)
#else
# define DEFIO_TAG__P115 defio_error_P115_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P115 DEFIO_TAG_E__NONE
# define DEFIO_REC__P115 defio_error_P115_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(0)
# define DEFIO_TAG__P20 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 0)
# define DEFIO_TAG_E__P20 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 0)
# define DEFIO_REC__P20 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P20 defio_error_P20_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P20 DEFIO_TAG_E__NONE
# define DEFIO_REC__P20 defio_error_P20_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(1)
# define DEFIO_TAG__P21 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 1)
# define DEFIO_TAG_E__P21 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 1)
# define DEFIO_REC__P21 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P21 defio_error_P21_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P21 DEFIO_TAG_E__NONE
# define DEFIO_REC__P21 defio_error_P21_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(2)
# define DEFIO_TAG__P22 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 2)
# define DEFIO_TAG_E__P22 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 2)
# define DEFIO_REC__P22 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P22 defio_error_P22_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P22 DEFIO_TAG_E__NONE
# define DEFIO_REC__P22 defio_error_P22_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(3)
# define DEFIO_TAG__P23 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 3)
# define DEFIO_TAG_E__P23 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 3)
# define DEFIO_REC__P23 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P23 defio_error_P23_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P23 DEFIO_TAG_E__NONE
# define DEFIO_REC__P23 defio_error_P23_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(4)
# define DEFIO_TAG__P24 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 4)
# define DEFIO_TAG_E__P24 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 4)
# define DEFIO_REC__P24 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P24 defio_error_P24_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P24 DEFIO_TAG_E__NONE
# define DEFIO_REC__P24 defio_error_P24_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(5)
# define DEFIO_TAG__P25 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 5)
# define DEFIO_TAG_E__P25 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 5)
# define DEFIO_REC__P25 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P25 defio_error_P25_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P25 DEFIO_TAG_E__NONE
# define DEFIO_REC__P25 defio_error_P25_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(6)
# define DEFIO_TAG__P26 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 6)
# define DEFIO_TAG_E__P26 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 6)
# define DEFIO_REC__P26 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P26 defio_error_P26_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P26 DEFIO_TAG_E__NONE
# define DEFIO_REC__P26 defio_error_P26_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(7)
# define DEFIO_TAG__P27 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 7)
# define DEFIO_TAG_E__P27 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 7)
# define DEFIO_REC__P27 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P27 defio_error_P27_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P27 DEFIO_TAG_E__NONE
# define DEFIO_REC__P27 defio_error_P27_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(8)
# define DEFIO_TAG__P28 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 8)
# define DEFIO_TAG_E__P28 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 8)
# define DEFIO_REC__P28 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P28 defio_error_P28_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P28 DEFIO_TAG_E__NONE
# define DEFIO_REC__P28 defio_error_P28_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(9)
# define DEFIO_TAG__P29 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 9)
# define DEFIO_TAG_E__P29 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 9)
# define DEFIO_REC__P29 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P29 defio_error_P29_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P29 DEFIO_TAG_E__NONE
# define DEFIO_REC__P29 defio_error_P29_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(10)
# define DEFIO_TAG__P210 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 10)
# define DEFIO_TAG_E__P210 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 10)
# define DEFIO_REC__P210 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P210 defio_error_P210_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P210 DEFIO_TAG_E__NONE
# define DEFIO_REC__P210 defio_error_P210_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(11)
# define DEFIO_TAG__P211 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 11)
# define DEFIO_TAG_E__P211 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 11)
# define DEFIO_REC__P211 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P211 defio_error_P211_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P211 DEFIO_TAG_E__NONE
# define DEFIO_REC__P211 defio_error_P211_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(12)
# define DEFIO_TAG__P212 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 12)
# define DEFIO_TAG_E__P212 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 12)
# define DEFIO_REC__P212 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P212 defio_error_P212_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P212 DEFIO_TAG_E__NONE
# define DEFIO_REC__P212 defio_error_P212_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(13)
# define DEFIO_TAG__P213 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 13)
# define DEFIO_TAG_E__P213 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 13)
# define DEFIO_REC__P213 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P213 defio_error_P213_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P213 DEFIO_TAG_E__NONE
# define DEFIO_REC__P213 defio_error_P213_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(14)
# define DEFIO_TAG__P214 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 14)
# define DEFIO_TAG_E__P214 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 14)
# define DEFIO_REC__P214 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P214 defio_error_P214_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P214 DEFIO_TAG_E__NONE
# define DEFIO_REC__P214 defio_error_P214_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_2_USED_MASK & BIT(15)
# define DEFIO_TAG__P215 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 15)
# define DEFIO_TAG_E__P215 DEFIO_TAG_MAKE(DEFIO_GPIOID__2, 15)
# define DEFIO_REC__P215 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_2_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT)
#else
# define DEFIO_TAG__P215 defio_error_P215_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P215 DEFIO_TAG_E__NONE
# define DEFIO_REC__P215 defio_error_P215_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(0)
# define DEFIO_TAG__P30 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 0)
# define DEFIO_TAG_E__P30 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 0)
# define DEFIO_REC__P30 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P30 defio_error_P30_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P30 DEFIO_TAG_E__NONE
# define DEFIO_REC__P30 defio_error_P30_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(1)
# define DEFIO_TAG__P31 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 1)
# define DEFIO_TAG_E__P31 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 1)
# define DEFIO_REC__P31 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P31 defio_error_P31_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P31 DEFIO_TAG_E__NONE
# define DEFIO_REC__P31 defio_error_P31_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(2)
# define DEFIO_TAG__P32 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 2)
# define DEFIO_TAG_E__P32 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 2)
# define DEFIO_REC__P32 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P32 defio_error_P32_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P32 DEFIO_TAG_E__NONE
# define DEFIO_REC__P32 defio_error_P32_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(3)
# define DEFIO_TAG__P33 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 3)
# define DEFIO_TAG_E__P33 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 3)
# define DEFIO_REC__P33 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P33 defio_error_P33_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P33 DEFIO_TAG_E__NONE
# define DEFIO_REC__P33 defio_error_P33_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(4)
# define DEFIO_TAG__P34 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 4)
# define DEFIO_TAG_E__P34 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 4)
# define DEFIO_REC__P34 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P34 defio_error_P34_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P34 DEFIO_TAG_E__NONE
# define DEFIO_REC__P34 defio_error_P34_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(5)
# define DEFIO_TAG__P35 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 5)
# define DEFIO_TAG_E__P35 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 5)
# define DEFIO_REC__P35 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P35 defio_error_P35_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P35 DEFIO_TAG_E__NONE
# define DEFIO_REC__P35 defio_error_P35_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(6)
# define DEFIO_TAG__P36 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 6)
# define DEFIO_TAG_E__P36 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 6)
# define DEFIO_REC__P36 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P36 defio_error_P36_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P36 DEFIO_TAG_E__NONE
# define DEFIO_REC__P36 defio_error_P36_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(7)
# define DEFIO_TAG__P37 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 7)
# define DEFIO_TAG_E__P37 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 7)
# define DEFIO_REC__P37 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P37 defio_error_P37_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P37 DEFIO_TAG_E__NONE
# define DEFIO_REC__P37 defio_error_P37_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(8)
# define DEFIO_TAG__P38 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 8)
# define DEFIO_TAG_E__P38 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 8)
# define DEFIO_REC__P38 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P38 defio_error_P38_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P38 DEFIO_TAG_E__NONE
# define DEFIO_REC__P38 defio_error_P38_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(9)
# define DEFIO_TAG__P39 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 9)
# define DEFIO_TAG_E__P39 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 9)
# define DEFIO_REC__P39 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P39 defio_error_P39_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P39 DEFIO_TAG_E__NONE
# define DEFIO_REC__P39 defio_error_P39_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(10)
# define DEFIO_TAG__P310 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 10)
# define DEFIO_TAG_E__P310 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 10)
# define DEFIO_REC__P310 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P310 defio_error_P310_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P310 DEFIO_TAG_E__NONE
# define DEFIO_REC__P310 defio_error_P310_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(11)
# define DEFIO_TAG__P311 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 11)
# define DEFIO_TAG_E__P311 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 11)
# define DEFIO_REC__P311 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P311 defio_error_P311_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P311 DEFIO_TAG_E__NONE
# define DEFIO_REC__P311 defio_error_P311_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(12)
# define DEFIO_TAG__P312 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 12)
# define DEFIO_TAG_E__P312 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 12)
# define DEFIO_REC__P312 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P312 defio_error_P312_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P312 DEFIO_TAG_E__NONE
# define DEFIO_REC__P312 defio_error_P312_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(13)
# define DEFIO_TAG__P313 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 13)
# define DEFIO_TAG_E__P313 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 13)
# define DEFIO_REC__P313 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P313 defio_error_P313_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P313 DEFIO_TAG_E__NONE
# define DEFIO_REC__P313 defio_error_P313_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(14)
# define DEFIO_TAG__P314 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 14)
# define DEFIO_TAG_E__P314 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 14)
# define DEFIO_REC__P314 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P314 defio_error_P314_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P314 DEFIO_TAG_E__NONE
# define DEFIO_REC__P314 defio_error_P314_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_3_USED_MASK & BIT(15)
# define DEFIO_TAG__P315 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 15)
# define DEFIO_TAG_E__P315 DEFIO_TAG_MAKE(DEFIO_GPIOID__3, 15)
# define DEFIO_REC__P315 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_3_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT)
#else
# define DEFIO_TAG__P315 defio_error_P315_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P315 DEFIO_TAG_E__NONE
# define DEFIO_REC__P315 defio_error_P315_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(0)
# define DEFIO_TAG__P40 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 0)
# define DEFIO_TAG_E__P40 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 0)
# define DEFIO_REC__P40 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P40 defio_error_P40_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P40 DEFIO_TAG_E__NONE
# define DEFIO_REC__P40 defio_error_P40_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(1)
# define DEFIO_TAG__P41 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 1)
# define DEFIO_TAG_E__P41 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 1)
# define DEFIO_REC__P41 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P41 defio_error_P41_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P41 DEFIO_TAG_E__NONE
# define DEFIO_REC__P41 defio_error_P41_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(2)
# define DEFIO_TAG__P42 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 2)
# define DEFIO_TAG_E__P42 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 2)
# define DEFIO_REC__P42 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P42 defio_error_P42_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P42 DEFIO_TAG_E__NONE
# define DEFIO_REC__P42 defio_error_P42_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(3)
# define DEFIO_TAG__P43 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 3)
# define DEFIO_TAG_E__P43 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 3)
# define DEFIO_REC__P43 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P43 defio_error_P43_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P43 DEFIO_TAG_E__NONE
# define DEFIO_REC__P43 defio_error_P43_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(4)
# define DEFIO_TAG__P44 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 4)
# define DEFIO_TAG_E__P44 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 4)
# define DEFIO_REC__P44 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P44 defio_error_P44_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P44 DEFIO_TAG_E__NONE
# define DEFIO_REC__P44 defio_error_P44_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(5)
# define DEFIO_TAG__P45 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 5)
# define DEFIO_TAG_E__P45 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 5)
# define DEFIO_REC__P45 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P45 defio_error_P45_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P45 DEFIO_TAG_E__NONE
# define DEFIO_REC__P45 defio_error_P45_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(6)
# define DEFIO_TAG__P46 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 6)
# define DEFIO_TAG_E__P46 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 6)
# define DEFIO_REC__P46 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P46 defio_error_P46_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P46 DEFIO_TAG_E__NONE
# define DEFIO_REC__P46 defio_error_P46_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(7)
# define DEFIO_TAG__P47 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 7)
# define DEFIO_TAG_E__P47 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 7)
# define DEFIO_REC__P47 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P47 defio_error_P47_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P47 DEFIO_TAG_E__NONE
# define DEFIO_REC__P47 defio_error_P47_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(8)
# define DEFIO_TAG__P48 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 8)
# define DEFIO_TAG_E__P48 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 8)
# define DEFIO_REC__P48 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P48 defio_error_P48_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P48 DEFIO_TAG_E__NONE
# define DEFIO_REC__P48 defio_error_P48_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(9)
# define DEFIO_TAG__P49 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 9)
# define DEFIO_TAG_E__P49 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 9)
# define DEFIO_REC__P49 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P49 defio_error_P49_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P49 DEFIO_TAG_E__NONE
# define DEFIO_REC__P49 defio_error_P49_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(10)
# define DEFIO_TAG__P410 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 10)
# define DEFIO_TAG_E__P410 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 10)
# define DEFIO_REC__P410 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P410 defio_error_P410_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P410 DEFIO_TAG_E__NONE
# define DEFIO_REC__P410 defio_error_P410_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(11)
# define DEFIO_TAG__P411 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 11)
# define DEFIO_TAG_E__P411 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 11)
# define DEFIO_REC__P411 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P411 defio_error_P411_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P411 DEFIO_TAG_E__NONE
# define DEFIO_REC__P411 defio_error_P411_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(12)
# define DEFIO_TAG__P412 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 12)
# define DEFIO_TAG_E__P412 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 12)
# define DEFIO_REC__P412 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P412 defio_error_P412_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P412 DEFIO_TAG_E__NONE
# define DEFIO_REC__P412 defio_error_P412_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(13)
# define DEFIO_TAG__P413 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 13)
# define DEFIO_TAG_E__P413 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 13)
# define DEFIO_REC__P413 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P413 defio_error_P413_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P413 DEFIO_TAG_E__NONE
# define DEFIO_REC__P413 defio_error_P413_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(14)
# define DEFIO_TAG__P414 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 14)
# define DEFIO_TAG_E__P414 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 14)
# define DEFIO_REC__P414 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P414 defio_error_P414_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P414 DEFIO_TAG_E__NONE
# define DEFIO_REC__P414 defio_error_P414_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_4_USED_MASK & BIT(15)
# define DEFIO_TAG__P415 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 15)
# define DEFIO_TAG_E__P415 DEFIO_TAG_MAKE(DEFIO_GPIOID__4, 15)
# define DEFIO_REC__P415 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_4_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT)
#else
# define DEFIO_TAG__P415 defio_error_P415_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P415 DEFIO_TAG_E__NONE
# define DEFIO_REC__P415 defio_error_P415_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(0)
# define DEFIO_TAG__P50 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 0)
# define DEFIO_TAG_E__P50 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 0)
# define DEFIO_REC__P50 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P50 defio_error_P50_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P50 DEFIO_TAG_E__NONE
# define DEFIO_REC__P50 defio_error_P50_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(1)
# define DEFIO_TAG__P51 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 1)
# define DEFIO_TAG_E__P51 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 1)
# define DEFIO_REC__P51 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P51 defio_error_P51_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P51 DEFIO_TAG_E__NONE
# define DEFIO_REC__P51 defio_error_P51_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(2)
# define DEFIO_TAG__P52 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 2)
# define DEFIO_TAG_E__P52 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 2)
# define DEFIO_REC__P52 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P52 defio_error_P52_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P52 DEFIO_TAG_E__NONE
# define DEFIO_REC__P52 defio_error_P52_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(3)
# define DEFIO_TAG__P53 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 3)
# define DEFIO_TAG_E__P53 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 3)
# define DEFIO_REC__P53 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P53 defio_error_P53_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P53 DEFIO_TAG_E__NONE
# define DEFIO_REC__P53 defio_error_P53_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(4)
# define DEFIO_TAG__P54 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 4)
# define DEFIO_TAG_E__P54 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 4)
# define DEFIO_REC__P54 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P54 defio_error_P54_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P54 DEFIO_TAG_E__NONE
# define DEFIO_REC__P54 defio_error_P54_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(5)
# define DEFIO_TAG__P55 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 5)
# define DEFIO_TAG_E__P55 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 5)
# define DEFIO_REC__P55 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P55 defio_error_P55_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P55 DEFIO_TAG_E__NONE
# define DEFIO_REC__P55 defio_error_P55_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(6)
# define DEFIO_TAG__P56 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 6)
# define DEFIO_TAG_E__P56 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 6)
# define DEFIO_REC__P56 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P56 defio_error_P56_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P56 DEFIO_TAG_E__NONE
# define DEFIO_REC__P56 defio_error_P56_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(7)
# define DEFIO_TAG__P57 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 7)
# define DEFIO_TAG_E__P57 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 7)
# define DEFIO_REC__P57 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P57 defio_error_P57_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P57 DEFIO_TAG_E__NONE
# define DEFIO_REC__P57 defio_error_P57_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(8)
# define DEFIO_TAG__P58 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 8)
# define DEFIO_TAG_E__P58 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 8)
# define DEFIO_REC__P58 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P58 defio_error_P58_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P58 DEFIO_TAG_E__NONE
# define DEFIO_REC__P58 defio_error_P58_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(9)
# define DEFIO_TAG__P59 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 9)
# define DEFIO_TAG_E__P59 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 9)
# define DEFIO_REC__P59 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P59 defio_error_P59_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P59 DEFIO_TAG_E__NONE
# define DEFIO_REC__P59 defio_error_P59_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(10)
# define DEFIO_TAG__P510 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 10)
# define DEFIO_TAG_E__P510 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 10)
# define DEFIO_REC__P510 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P510 defio_error_P510_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P510 DEFIO_TAG_E__NONE
# define DEFIO_REC__P510 defio_error_P510_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(11)
# define DEFIO_TAG__P511 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 11)
# define DEFIO_TAG_E__P511 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 11)
# define DEFIO_REC__P511 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P511 defio_error_P511_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P511 DEFIO_TAG_E__NONE
# define DEFIO_REC__P511 defio_error_P511_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(12)
# define DEFIO_TAG__P512 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 12)
# define DEFIO_TAG_E__P512 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 12)
# define DEFIO_REC__P512 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P512 defio_error_P512_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P512 DEFIO_TAG_E__NONE
# define DEFIO_REC__P512 defio_error_P512_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(13)
# define DEFIO_TAG__P513 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 13)
# define DEFIO_TAG_E__P513 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 13)
# define DEFIO_REC__P513 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P513 defio_error_P513_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P513 DEFIO_TAG_E__NONE
# define DEFIO_REC__P513 defio_error_P513_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(14)
# define DEFIO_TAG__P514 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 14)
# define DEFIO_TAG_E__P514 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 14)
# define DEFIO_REC__P514 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P514 defio_error_P514_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P514 DEFIO_TAG_E__NONE
# define DEFIO_REC__P514 defio_error_P514_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_5_USED_MASK & BIT(15)
# define DEFIO_TAG__P515 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 15)
# define DEFIO_TAG_E__P515 DEFIO_TAG_MAKE(DEFIO_GPIOID__5, 15)
# define DEFIO_REC__P515 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_5_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT)
#else
# define DEFIO_TAG__P515 defio_error_P515_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P515 DEFIO_TAG_E__NONE
# define DEFIO_REC__P515 defio_error_P515_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(0)
# define DEFIO_TAG__P60 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 0)
# define DEFIO_TAG_E__P60 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 0)
# define DEFIO_REC__P60 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(0) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P60 defio_error_P60_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P60 DEFIO_TAG_E__NONE
# define DEFIO_REC__P60 defio_error_P60_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(1)
# define DEFIO_TAG__P61 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 1)
# define DEFIO_TAG_E__P61 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 1)
# define DEFIO_REC__P61 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(1) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P61 defio_error_P61_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P61 DEFIO_TAG_E__NONE
# define DEFIO_REC__P61 defio_error_P61_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(2)
# define DEFIO_TAG__P62 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 2)
# define DEFIO_TAG_E__P62 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 2)
# define DEFIO_REC__P62 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(2) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P62 defio_error_P62_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P62 DEFIO_TAG_E__NONE
# define DEFIO_REC__P62 defio_error_P62_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(3)
# define DEFIO_TAG__P63 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 3)
# define DEFIO_TAG_E__P63 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 3)
# define DEFIO_REC__P63 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(3) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P63 defio_error_P63_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P63 DEFIO_TAG_E__NONE
# define DEFIO_REC__P63 defio_error_P63_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(4)
# define DEFIO_TAG__P64 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 4)
# define DEFIO_TAG_E__P64 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 4)
# define DEFIO_REC__P64 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(4) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P64 defio_error_P64_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P64 DEFIO_TAG_E__NONE
# define DEFIO_REC__P64 defio_error_P64_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(5)
# define DEFIO_TAG__P65 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 5)
# define DEFIO_TAG_E__P65 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 5)
# define DEFIO_REC__P65 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(5) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P65 defio_error_P65_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P65 DEFIO_TAG_E__NONE
# define DEFIO_REC__P65 defio_error_P65_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(6)
# define DEFIO_TAG__P66 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 6)
# define DEFIO_TAG_E__P66 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 6)
# define DEFIO_REC__P66 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(6) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P66 defio_error_P66_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P66 DEFIO_TAG_E__NONE
# define DEFIO_REC__P66 defio_error_P66_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(7)
# define DEFIO_TAG__P67 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 7)
# define DEFIO_TAG_E__P67 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 7)
# define DEFIO_REC__P67 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(7) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P67 defio_error_P67_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P67 DEFIO_TAG_E__NONE
# define DEFIO_REC__P67 defio_error_P67_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(8)
# define DEFIO_TAG__P68 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 8)
# define DEFIO_TAG_E__P68 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 8)
# define DEFIO_REC__P68 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(8) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P68 defio_error_P68_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P68 DEFIO_TAG_E__NONE
# define DEFIO_REC__P68 defio_error_P68_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(9)
# define DEFIO_TAG__P69 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 9)
# define DEFIO_TAG_E__P69 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 9)
# define DEFIO_REC__P69 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(9) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P69 defio_error_P69_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P69 DEFIO_TAG_E__NONE
# define DEFIO_REC__P69 defio_error_P69_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(10)
# define DEFIO_TAG__P610 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 10)
# define DEFIO_TAG_E__P610 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 10)
# define DEFIO_REC__P610 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(10) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P610 defio_error_P610_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P610 DEFIO_TAG_E__NONE
# define DEFIO_REC__P610 defio_error_P610_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(11)
# define DEFIO_TAG__P611 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 11)
# define DEFIO_TAG_E__P611 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 11)
# define DEFIO_REC__P611 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(11) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P611 defio_error_P611_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P611 DEFIO_TAG_E__NONE
# define DEFIO_REC__P611 defio_error_P611_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(12)
# define DEFIO_TAG__P612 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 12)
# define DEFIO_TAG_E__P612 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 12)
# define DEFIO_REC__P612 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(12) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P612 defio_error_P612_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P612 DEFIO_TAG_E__NONE
# define DEFIO_REC__P612 defio_error_P612_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(13)
# define DEFIO_TAG__P613 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 13)
# define DEFIO_TAG_E__P613 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 13)
# define DEFIO_REC__P613 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(13) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P613 defio_error_P613_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P613 DEFIO_TAG_E__NONE
# define DEFIO_REC__P613 defio_error_P613_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(14)
# define DEFIO_TAG__P614 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 14)
# define DEFIO_TAG_E__P614 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 14)
# define DEFIO_REC__P614 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(14) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P614 defio_error_P614_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P614 DEFIO_TAG_E__NONE
# define DEFIO_REC__P614 defio_error_P614_is_not_supported_on_TARGET
#endif
#if DEFIO_PORT_6_USED_MASK & BIT(15)
# define DEFIO_TAG__P615 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 15)
# define DEFIO_TAG_E__P615 DEFIO_TAG_MAKE(DEFIO_GPIOID__6, 15)
# define DEFIO_REC__P615 DEFIO_REC_INDEXED(BITCOUNT(DEFIO_PORT_6_USED_MASK & (BIT(15) - 1)) + DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT)
#else
# define DEFIO_TAG__P615 defio_error_P615_is_not_supported_on_TARGET
# define DEFIO_TAG_E__P615 DEFIO_TAG_E__NONE
# define DEFIO_REC__P615 defio_error_P615_is_not_supported_on_TARGET
#endif

// DEFIO_IO_USED_COUNT is number of io pins supported on target
#define DEFIO_IO_USED_COUNT (DEFIO_PORT_0_USED_COUNT+DEFIO_PORT_1_USED_COUNT+DEFIO_PORT_2_USED_COUNT+DEFIO_PORT_3_USED_COUNT+DEFIO_PORT_4_USED_COUNT+DEFIO_PORT_5_USED_COUNT+DEFIO_PORT_6_USED_COUNT)

// DEFIO_PORT_USED_LIST - comma separated list of bitmask for all used ports.
// DEFIO_PORT_OFFSET_LIST - comma separated list of port offsets (count of pins before this port)
// unused ports on end of list are skipped
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_6_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 7
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK,DEFIO_PORT_2_USED_MASK,DEFIO_PORT_3_USED_MASK,DEFIO_PORT_4_USED_MASK,DEFIO_PORT_5_USED_MASK,DEFIO_PORT_6_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET,DEFIO_PORT_2_OFFSET,DEFIO_PORT_3_OFFSET,DEFIO_PORT_4_OFFSET,DEFIO_PORT_5_OFFSET,DEFIO_PORT_6_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_5_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 6
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK,DEFIO_PORT_2_USED_MASK,DEFIO_PORT_3_USED_MASK,DEFIO_PORT_4_USED_MASK,DEFIO_PORT_5_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET,DEFIO_PORT_2_OFFSET,DEFIO_PORT_3_OFFSET,DEFIO_PORT_4_OFFSET,DEFIO_PORT_5_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_4_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 5
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK,DEFIO_PORT_2_USED_MASK,DEFIO_PORT_3_USED_MASK,DEFIO_PORT_4_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET,DEFIO_PORT_2_OFFSET,DEFIO_PORT_3_OFFSET,DEFIO_PORT_4_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_3_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 4
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK,DEFIO_PORT_2_USED_MASK,DEFIO_PORT_3_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET,DEFIO_PORT_2_OFFSET,DEFIO_PORT_3_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_2_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 3
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK,DEFIO_PORT_2_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET,DEFIO_PORT_2_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_1_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 2
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK,DEFIO_PORT_1_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET,DEFIO_PORT_1_OFFSET
#endif
#if !defined DEFIO_PORT_USED_LIST && DEFIO_PORT_0_USED_COUNT > 0
# define DEFIO_PORT_USED_COUNT 1
# define DEFIO_PORT_USED_LIST DEFIO_PORT_0_USED_MASK
# define DEFIO_PORT_OFFSET_LIST DEFIO_PORT_0_OFFSET
#endif

#if !defined(DEFIO_PORT_USED_LIST)
# if !defined DEFIO_NO_PORTS   // supress warnings if we really don't want any pins
#  warning "No pins are defined. Maybe you forgot to define TARGET_IO_PORTx in target.h"
# endif
# define DEFIO_PORT_USED_COUNT 0
# define DEFIO_PORT_USED_LIST /* empty */
# define DEFIO_PORT_OFFSET_LIST /* empty */
#endif

